declare type AnyFn = (...params: any[]) => any;
/**
 * @internal
 */
export default function flow<First extends unknown, Output>(first: (val: First) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Output>(first: (val: First) => Second, second: (val: Second) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Fifth, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Fifth, fifth: (val: Fifth) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Fifth, Sixth, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Fifth, fifth: (val: Fifth) => Sixth, sixth: (val: Sixth) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Fifth, Sixth, Seventh, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Fifth, fifth: (val: Fifth) => Sixth, sixth: (val: Sixth) => Seventh, seventh: (val: Seventh) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Fifth, Sixth, Seventh, Eighth, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Fifth, fifth: (val: Fifth) => Sixth, sixth: (val: Sixth) => Seventh, seventh: (val: Seventh) => Eighth, eighth: (val: Eighth) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Fifth, Sixth, Seventh, Eighth, Ninth, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Fifth, fifth: (val: Fifth) => Sixth, sixth: (val: Sixth) => Seventh, seventh: (val: Seventh) => Eighth, eighth: (val: Eighth) => Ninth, ninth: (val: Ninth) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow<First extends unknown, Second, Third, Fourth, Fifth, Sixth, Seventh, Eighth, Ninth, Tenth, Output>(first: (val: First) => Second, second: (val: Second) => Third, third: (val: Third) => Fourth, fourth: (val: Fourth) => Fifth, fifth: (val: Fifth) => Sixth, sixth: (val: Sixth) => Seventh, seventh: (val: Seventh) => Eighth, eighth: (val: Eighth) => Ninth, ninth: (val: Ninth) => Tenth, tenth: (val: Tenth) => Output): (val: First) => Output;
/**
 * @internal
 */
export default function flow(...fns: AnyFn[]): AnyFn;
export {};
