'use strict'

exports.default = flow

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * @internal
 */

/**
 * Lets you perform a flow of function operations sequentially
 *
 * @param functions - The function operations that you want to perform on a given value
 * @returns A function that accepts an initial value to perform the above functions on
 *
 * @category Util
 * @public
 */
function flow() {
  for (
    var _len = arguments.length, fns = new Array(_len), _key = 0;
    _key < _len;
    _key++
  ) {
    fns[_key] = arguments[_key]
  }

  return function (initialValue) {
    return fns.reduce(function (val, fn) {
      return fn(val)
    }, initialValue)
  }
}
