/**
 * Removes null and undefined elements from the given array.
 *
 * @param array - The array to remove elements from
 * @returns An array without elements equal null or undefined
 *
 * @category Array
 * @public
 */
export default function sweep(array) {
  return array.filter(function (item) {
    return item != null
  })
}
