/**
 * Creates a new array without elements from the second argument.
 *
 * @param inputArray - The array to remove elements from
 * @param arrayToSubstract - The array of elements to remove
 * @returns An array basing of the first one without element from the second
 *
 * @category Array
 * @public
 */
export default function difference(inputArray, arrayToSubtract) {
  return inputArray.filter(function (item) {
    return arrayToSubtract.indexOf(item) === -1
  })
}
