/**
 * Creates an array of arrays where the first element is the key and second is the value.
 *
 * @param object - The object to get entries from
 * @returns Array of entries
 *
 * @public
 */
export default function entries(object) {
  return Object.keys(object).reduce(function (acc, key) {
    return acc.concat([[key, object[key]]])
  }, [])
}
