'use strict'

exports.default = remove

/**
 * Creates an array without the given element.
 *
 * @param array - The array to remove the element from
 * @param element - The element to remove
 *
 * @category Array
 * @public
 */
function remove(array, element) {
  return array.filter(function (el) {
    return el !== element
  })
}
