/**
 * Returns a random element from the given array.
 *
 * @param array - The array to get element from
 * @returns A random element
 *
 * @category Array
 * @public
 */
export default function sample(array) {
  var randomIndex = Math.round(Math.random() * (array.length - 1))
  return array[randomIndex]
}
