'use strict'

exports.default = truthy

/**
 * Removes falsy elements (null, undefined, false, 0 and '') from the given array.
 *
 * @param array - The array to remove elements from
 * @returns An array without falsy elements
 *
 * @category Array
 * @public
 */
function truthy(array) {
  return array.filter(function (item) {
    return !!item
  })
}
